package com.ruoyi.gysl.service;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.IService;
import com.ruoyi.gysl.entity.BasicInformation;
import com.ruoyi.gysl.entity.request.BasicInformationPageReq;
import com.ruoyi.gysl.entity.response.ProjectBuildingExcel;
import com.ruoyi.gysl.entity.response.ProjectExcelInfo;
import org.apache.poi.xssf.usermodel.XSSFCellStyle;
import org.apache.poi.xssf.usermodel.XSSFSheet;

import java.util.List;
import java.util.Map;

/**
 * 基本信息(BasicInformation)表服务接口
 *
 * @author makejava
 * @since 2025-02-24 09:25:55
 */
public interface BasicInformationService extends IService<BasicInformation> {

    /**
     * 分页查询所有数据
     *
     * @param page             分页对象
     * @param req 查询实体
     * @return 所有数据
     */
    Page<BasicInformation> page(Page<BasicInformation> page, BasicInformationPageReq req);


    /**
     * 根据基本信息的id列表来查找
     */
    List<ProjectExcelInfo> selectList(List<Long> idList);

    /**
     * 填充数据
     */
    void approvalMethodfillInData(XSSFSheet sheet, XSSFCellStyle contentStyle, int rowNum, List<ProjectExcelInfo> info,List<String> sc,List<String> ec,int a) ;

    /**
     * 填充数据-项目基础信息获取
     */
    String getExcelData(ProjectExcelInfo item,String str);

    /**
     * 填充数据-项目建筑信息获取
     */
    String getBuildingData(ProjectBuildingExcel item,String str);
}

